import Knex from "knex";
import { Model, QueryBuilder } from "objection";
export declare class UserModel extends Model {
    static tableName: string;
    static get relationMappings(): {
        posts: {
            relation: import("objection").RelationType;
            modelClass: typeof PostModel;
            join: {
                from: string;
                to: string;
            };
        };
        default_section: {
            relation: import("objection").RelationType;
            modelClass: typeof SectionModel;
            join: {
                from: string;
                to: string;
            };
        };
    };
    static modifiers: {
        "graphql.select.upper_name": (query: QueryBuilder<UserModel>) => QueryBuilder<UserModel, UserModel[]>;
    };
    id: number;
    name: string;
    readonly upper_name: string;
    password: string;
    posts: PostModel[];
    default_section_id: number;
    default_section: SectionModel;
}
export declare class SectionModel extends Model {
    static tableName: string;
    static get relationMappings(): {
        posts: {
            relation: import("objection").RelationType;
            modelClass: typeof PostModel;
            join: {
                from: string;
                to: string;
            };
        };
    };
    static modifiers: {
        "graphql.top": (query: QueryBuilder<UserModel>) => QueryBuilder<UserModel, UserModel[]>;
        "graphql.many": (query: QueryBuilder<UserModel>) => QueryBuilder<UserModel, UserModel[]>;
    };
    id: number;
    slug: string;
    name: string;
    is_hidden: boolean;
    posts: PostModel[];
}
export declare class PostModel extends Model {
    static tableName: string;
    static get relationMappings(): {
        author: {
            relation: import("objection").RelationType;
            modelClass: typeof UserModel;
            join: {
                from: string;
                to: string;
            };
        };
        section: {
            relation: import("objection").RelationType;
            modelClass: typeof SectionModel;
            join: {
                from: string;
                to: string;
            };
        };
    };
    static modifiers: {
        published(query: QueryBuilder<PostModel>): void;
        search(query: QueryBuilder<PostModel>, term: string): void;
        under_default_section(query: QueryBuilder<PostModel>, { user_id }: {
            user_id: string;
        }): void;
        "graphql.select.url": (query: QueryBuilder<PostModel>) => QueryBuilder<PostModel, PostModel[]>;
    };
    id: number;
    title: string | null;
    text: string | null;
    author: UserModel;
    section: SectionModel;
    get url(): string;
}
export declare function create_tables(knex: Knex): Promise<void>;
